package logic

import (
	"encoding/json"
	"fmt"
	"fusenapi/initalize"
	"fusenapi/utils/check"
	"log"
	"strings"
	"testing"

	"github.com/zeromicro/go-zero/core/logx"
	"gorm.io/gorm"
)

func TestMain(t *testing.T) {

	conn := initalize.InitMysql("fsreaderwriter:XErSYmLELKMnf3Dh@tcp(fusen.cdmigcvz3rle.us-east-2.rds.amazonaws.com:3306)/fusen")
	cond := "user_id = 105 and guest_id = 0"

	var mquerys map[string]*ModuleQuery = make(map[string]*ModuleQuery)
	var metadict map[string]any = make(map[string]any)

	for _, module := range []string{"material.logo_url"} {
		if !check.CheckModuleQuery(module) {

		}

		mlist := strings.Split(module, ".")
		if len(mlist) == 0 {

		}

		mtable := mlist[0]
		tname, ok := ModuleTable[mtable]
		if !ok {

		}

		if mquery, ok := mquerys[mtable]; ok {
			mquery.ModuleQuery[strings.Join(mlist[1:], ",")] = struct{}{}
		} else {
			mquery := &ModuleQuery{
				TableName:   tname,
				ModuleName:  mtable,
				ModuleQuery: map[string]struct{}{strings.Join(mlist[1:], ","): {}}}
			mquerys[mtable] = mquery
		}
	}

	for _, mquery := range mquerys {

		sqlstr := fmt.Sprintf("select id, module, %s as querydata from %s where %s order by ctime asc", mquery.EncodeQuery("metadata"), mquery.TableName, cond)

		raw := conn.Raw(sqlstr)

		if raw.Error != nil {
			if raw.Error == gorm.ErrRecordNotFound {
				continue
			} else {
				logx.Error(raw.Error)

			}
		}

		var info map[string]any = make(map[string]any)
		err := raw.Scan(&info).Error
		if err == gorm.ErrRecordNotFound {
			continue
		}

		if err != nil {
			logx.Error(err, mquery.EncodeQuery("metadata"))

		}

		logx.Error(info["querydata"].(string))
		var querydata map[string]any = make(map[string]any)
		err = json.Unmarshal([]byte(info["querydata"].(string)), &querydata)
		if err != nil {
			logx.Error(err, info)

		}

		log.Println(querydata)

		for k, v := range querydata {
			metadict[k] = v
		}
	}

	return
}
